#ifndef FIN_EL_NET_STRUCTURES_H
#define FIN_EL_NET_STRUCTURES_H
#include <vector>
#include "iostream"
using namespace std;
struct Node{
    int id;
    double x, y, z;
    bool is_summit;
    friend std::ostream &operator<<(std::ostream &, const Node &);
    friend std::ostream &operator<<(std::ostream &, const std::vector<Node> &);
};
struct FiniteElement{
    int fe_id;
    int mat_id;
    vector <int> nodes_id;

    friend std::ostream &operator<<(std::ostream &, const FiniteElement &);
    friend std::ostream &operator<<(std::ostream &, const std::vector<FiniteElement> &);
};
struct BoundaryFiniteElement : public FiniteElement{
    int bfe_id;
    int border_id;

    friend std::ostream &operator<<(std::ostream &, const BoundaryFiniteElement &);
    friend std::ostream &operator<<(std::ostream &, const std::vector<BoundaryFiniteElement> &);
};
#endif //FIN_EL_NET_STRUCTURES_H
