#include "AneuMeshLoader.h"
#include "NeuMeshLoader.h"
#include <iostream>
#include <string>
#include <algorithm>
#include <string_view>
using namespace std;
bool f;
void test(MeshLoader *loader, const std::string &path) {
    loader->LoadMesh(path);
    vector<Node> nodes;
    vector<FiniteElement> fes;
    vector<BoundaryFiniteElement> bfes;

    cout << "In case to test, I'll find a finite element made by material 1:" << endl;
    fes = loader->Get_FE_by_material(1);
    if (fes.size() == 0)
        cout << "No such finite elements" << endl;
    else
    {
        cout << fes << endl;
        fes.clear();
    }
    cout << "Also in that case I'll find finite element by nodes with ids 0 0 0:" << endl;
    fes = loader->Get_FE_by_nodes(2, 4, 7);
    if (fes.size() == 0)
        cout << "No such finite elements" << endl;
    else
    {
        cout << fes << endl;
        fes.clear();
    }
}

int main(int argc, char** argv) {
    string path = "../myfile.aneu";
    MeshLoader *loader;
    if (argc == 1)
        cout << "No files were given, so we will work with one I keep." << endl;
    else if (argc == 2) {
        path = argv[1];
        cout << "Working with file " << path << endl;
    }
    else
        cout << "There are too many file locations were given, so we will work with one I keep." << endl;
    if (path.rfind( ".aneu") != string::npos)
    {
        loader = new AneuMeshLoader;
    }
    else if(path.rfind( ".neu") != string::npos)
    {
        loader = new NeuMeshLoader;
    }
    else{
        cout << "Error! Unexpected file format!" << endl;
        return 0;
    }
    test(loader, path);
    return 0;
}
